/*
 * jQuery Active Roll by CattleMute
 * copyright (c) cattlemute
 * 
 * Will follow the license of jQuery.
 */


(function($){

	$.fn.activeroll = function(options){
		var option = {
			frame: 30,
			position: 50,
			hover: true,
			hold: true,
			column: {
				normal: [0, 4],
			},
		};
		var static = {
			content: 'activeroll-content',
			wrap: 'activeroll-wrap',
			rebirth: 'activeroll-rebirth',
			column: 'activeroll-column',
			start: 'activeroll-start',
			active: 'activeroll-active',
		};
		var config = $.extend(option, options);
		var inc = $(this), mv = new Array(), si;
		var ua = window.navigator.userAgent.toLowerCase();

		var activeroll = (function(){
			return{
				init: function(){
					inc.addClass(static.content)
						.css({'overflow': 'hidden', 'position': 'relative'})
						.children().addClass(static.column);

					$('.' + static.content).wrapInner('<div class="' + static.rebirth + '" />')
						.each(function(){
							var html = $(this).html();
							$(this).append(html);
							$(this).children('.' + static.rebirth).css({'float': 'left'});
						});

					$('.' + static.content).wrapInner('<div class="' + static.wrap + '" />')
						.children('.' + static.wrap).css({'position': 'absolute', 'top': 0, 'left': 0});

					$('.' + static.content).each(function(){
						activeroll.disequip($(this));
					});

					this.stack();
					this.size();
					this.clip();
				},
				clip: function(){
					$(window).bind({
						'load': function(){
							activeroll.showin();
							activeroll.interval();
						},
						'resize': function(){
							$('.' + static.content).each(function(){
								activeroll.disequip($(this));
							});
							activeroll.size();
						},
						'scroll': function(){
							activeroll.showin();
						},
					});
					$('.' + static.content).bind({
						'mouseenter': function(){
							if(config.hover && (ua.indexOf('windows') > -1 || ua.indexOf('macintosh') > -1 || ua.indexOf('linux') > -1))
								$(this).addClass(static.active);
						},
						'mouseleave': function(){
							$(this).removeClass(static.active);
						},
					});
					if('ontouchstart' in window){
						$('.' + static.content).bind({
							'touchstart': function(){
								if(config.hold)
									$('.' + static.content).addClass(static.active);
							},
							'touchend': function(){
								$('.' + static.content).removeClass(static.active);
							},
						});
					}
				},
				stack: function(){
					$('.' + static.content).each(function(n){
						mv[n] = $(this);
					});
				},
				lack: function(base){
					if(base.find('.' + static.rebirth).eq(0).find('.' + static.column).length <= activeroll.colset())
						return true;
					else
						return false;
				},
				disequip: function(base){
					if(this.lack(base)){
						base.children('.' + static.wrap).css({'left': 0});
						base.find('.' + static.rebirth).eq(1).css({'display': 'none'});
					}else{
						base.find('.' + static.rebirth).eq(1).css({'display': ''});
					}
				},
				size: function(){
					$('.' + static.content).each(function(){
						var w = $(this).width() / activeroll.colset();
						$(this).find('.' + static.column).css({'width': w, 'float': 'left'});
						$(this).find('.' + static.rebirth).css({'width': w * $(this).find('.' + static.column).length / 2});
						$(this).css({'height': $(this).find('.' + static.rebirth).outerHeight()})
							.children('.' + static.wrap).css({'width': w * $(this).find('.' + static.column).length});
					});
				},
				colset: function(){
					var w = window.innerWidth, r = 1;
					for(var key in config.column){
						if(config.column[key][0] >= w || config.column[key][0] == 0){
							r = config.column[key][1];
						}
					}
					return r;
				},
				showin: function(){
					$('.' + static.content).each(function(){
						if( $(this).offset().top <= $(window).scrollTop() + (window.innerHeight * (config.position * 0.01)) ){
							$(this).addClass(static.start);
						}
					});
				},
				interval: function(){
					si = setInterval(function(){
						for(var i = 0; i < mv.length; i++){
							var m = mv[i], p = parseInt(m.children('.' + static.wrap).css('left'), 10);
							if(m.hasClass(static.start) && ! m.hasClass(static.active) && ! activeroll.lack(m)){
								if(m.find('.' + static.rebirth).width() >= p * -1 )
									m.children('.' + static.wrap).css({'left': p - 1 });
								else
									m.children('.' + static.wrap).css({'left': 0 });
							}
						}
					}, 1000 / config.frame );
				},
			};
		})();

		activeroll.init();

		return(this);
	};

})(jQuery);
